unit WinSCard;

interface

uses Windows, Sysutils;

type
  SCARDHANDLE   = ULONG;
  PSCARDHANDLE  = ^SCARDHANDLE;
  LPSCARDHANDLE = PSCARDHANDLE;

  SCARDCONTEXT   = ULONG;
  PSCARDCONTEXT  = ^SCARDCONTEXT;
  LPSCARDCONTEXT = PSCARDCONTEXT;

  LPBYTE = ^BYTE;

  SCARD_IO_REQUEST = record
    dwProtocol: ULONG;
	  cbPciLength: ULONG;
  end;
  PSCARD_IO_REQUEST = ^SCARD_IO_REQUEST;
  LPSCARD_IO_REQUEST = PSCARD_IO_REQUEST;
  LPCSCARD_IO_REQUEST = PSCARD_IO_REQUEST;

const
  WinSCard_dll = 'Winscard.dll';

  MAX_ATR_SIZE = 3;

  SCARD_PROTOCOL_T0	= $0001;
  SCARD_PROTOCOL_T1 = $0002;
  SCARD_PROTOCOL_RAW = $0004;

  SCARD_STATE_UNAWARE = $0000;
  SCARD_STATE_IGNORE = $0001;
  SCARD_STATE_CHANGED = $0002;
  SCARD_STATE_UNKNOWN = $0004;
  SCARD_STATE_UNAVAILABLE = $0008;
  SCARD_STATE_EMPTY = $0010;
  SCARD_STATE_PRESENT = $0020;
  SCARD_STATE_EXCLUSIVE = $0080;
  SCARD_STATE_INUSE = $0100;
  SCARD_STATE_MUTE = $0200;
  SCARD_STATE_UNPOWERED = $0400;


  SCARD_SHARE_EXCLUSIVE = $0001;
  SCARD_SHARE_SHARED = $0002;
  SCARD_SHARE_DIRECT = $0003;

  SCARD_LEAVE_CARD = $0000;
  SCARD_RESET_CARD = $0001;
  SCARD_UNPOWER_CARD = $0002;

  SCARD_AUTOALLOCATE = DWORD(-1);

  SCARD_SCOPE_USER = 0;
  SCARD_SCOPE_TERMINAL = 1;
  SCARD_SCOPE_SYSTEM = 2;

  SCARD_PCI_T0: SCARD_IO_REQUEST =
    (dwProtocol: SCARD_PROTOCOL_T0; cbPciLength: SizeOf(SCARD_IO_REQUEST));
  SCARD_PCI_T1: SCARD_IO_REQUEST =
    (dwProtocol: SCARD_PROTOCOL_T1; cbPciLength: SizeOf(SCARD_IO_REQUEST));
  SCARD_PCI_RAW: SCARD_IO_REQUEST =
    (dwProtocol: SCARD_PROTOCOL_RAW; cbPciLength: SizeOf(SCARD_IO_REQUEST));

  SCARD_S_SUCCESS	 = $00000000;
  SCARD_E_CANCELLED = $80100002;
  SCARD_E_INVALID_HANDLE = $80100003;
  SCARD_E_INVALID_PARAMETER = $80100004;
  SCARD_E_TIMEOUT	 = $8010000A;
  SCARD_E_SHARING_VIOLATION	= $8010000B;
  SCARD_E_NO_SMARTCARD = $8010000C;
  SCARD_E_PROTO_MISMATCH = $8010000F;
  SCARD_E_NOT_TRANSACTED = $80100016;
  SCARD_E_READER_UNAVAILABLE = $8010001;
  SCARD_E_NO_SERVICE = $8010001D;
  SCARD_E_NO_READERS_AVAILABLE = $8010002E;
  SCARD_W_UNRESPONSIVE_CARD = $80100066;
  SCARD_W_UNPOWERED_CARD = $80100067;
  SCARD_W_RESET_CARD = $80100068;
  SCARD_W_REMOVED_CARD = $80100069;


function SCardEstablishContext(dwScope: DWORD; pvReserved1: Pointer;
  pvReserved2: Pointer; phContext: LPSCARDCONTEXT): Longint; stdcall;
  external WinSCard_dll;

function SCardReleaseContext(hContext: SCARDCONTEXT): Longint; stdcall;
  external WinSCard_dll;

function SCardListReaders(hContext: SCARDCONTEXT; mszGroups: PAnsiChar;
  mszReaders: Pointer; pcchReaders: LPDWORD): Longint; stdcall;
  external WinSCard_dll name 'SCardListReadersA';  // (ANSI)

function SCardFreeMemory(hContext: SCARDCONTEXT; pvMem: Pointer): Longint;
  stdcall; external WinSCard_dll;

function SCardConnect(hContext: SCARDCONTEXT; szReader: PAnsiChar;
  dwShareMode: DWORD; dwPreferredProtocols: DWORD; phCard: LPSCARDHANDLE;
  pdwActiveProtocol: LPDWORD): Longint; stdcall;
  external WinSCard_dll name 'SCardConnectA';  // (ANSI)

function SCardDisconnect(hCard: SCARDHANDLE; dwDisposition: DWORD): Longint;
  stdcall; external WinSCard_dll;

function SCardStatus(hCard: SCARDHANDLE; szReaderName: PAnsiChar;
  pcchReaderLen: LPDWORD; pdwState: LPDWORD; pdwProtocol: LPDWORD;
  pbAtr: LPBYTE; pcbAtrLen: LPDWORD): Longint; stdcall;
  external WinSCard_dll name 'SCardStatusA';  // (ANSI)

function SCardTransmit(hCard: SCARDHANDLE; pioSendPci: LPCSCARD_IO_REQUEST;
  pbSendBuffer: Pointer; cbSendLength: DWORD; pioRecvPci: LPSCARD_IO_REQUEST;
  pbRecvBuffer: LPBYTE; pcbRecvLength: LPDWORD): Longint;
  stdcall; external WinSCard_dll;

implementation

end.
